#!/bin/sh
# Mini/Temporary ProteanOS Development Kit
# miniprokit.sh
# Main program file
#
# Copyright (C) 2013, 2014 Patrick "P. J." McDermott
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see .
set -u
SHA256SUMS='
ff4c0b1d3e8e7dfb00442b6cae1ad076b13329aa92edf516ae9c65563edb209f all_all_base
10e53d3d80f37153a8d428c47d37b770386b1252a9c76e562927a273e43d549e amd64-linux-glibc_all_base
a189b7ef5b35364aad0b72e2419dcc791eb28f8b725346fc727a99ddf099624e amd64-linux-glibc_dev_base
733f5b298450c5f2c2cdbb35030100c6c4c44661c0af52307ff2f8c49d16b1e7 i686-linux-glibc_all_base
0122eaaf5afe74d406e608c0b1aa6c9ec2d9d017f5d6a241beaa03d712bbdd6f i686-linux-glibc_ao751h_base
361015543e3326c85a89a0a735cd506f7a52ad9423b82de745fd333963ac8fdf i686-linux-glibc_dev_base
c93dc8608cf9a435b920c9cc9590c9d274c8193b709845cc5409692f00d8b05d src_all_base
'
PKGS=' base-files busybox '\
'libc-bin libc.6 libopkg.1 opkg '
main()
{
local cmd=
if [ ${#} -lt 1 ]; then
print_usage >&2
exit 1
fi
cmd="${1}"
shift 1
case "${cmd}" in
'install')
cmd_install "${@}"
;;
'shell')
cmd_shell "${@}"
;;
esac
return 0
}
print_usage()
{
printf 'Usage: %s []\n\n' "${0}"
printf 'Available commands are:\n'
printf ' install install a ProteanOS system\n'
printf ' shell enter a ProteanOS shell\n'
}
error()
{
local status=${1}
local fmt="${2}"
shift 2
printf "Error: ${fmt}\n" "${@}" >&2
exit ${status}
}
info()
{
local fmt="${1}"
shift 1
printf "${fmt}\n" "${@}"
}
cmd_install()
{
local usage=
local opt=
local arch=
local plat=
local mirror=
local root=
local uname_m=
local uname_s=
local aps=
local url_aps=
local feed=
local sha256sum=
local line=
local package=
local filename=
usage='[-a ] [-P ] [-m ] '
while getopts 'a:P:m:' opt; do
case ${opt} in
a) arch="${OPTARG}";;
P) plat="${OPTARG}";;
m) mirror="${OPTARG}";;
?)
printf 'Usage: %s install %s\n' \
"${0}" "${usage}" >&2
exit 1
;;
esac
done
shift $(($OPTIND - 1))
if [ ${#} -ne 1 ]; then
printf 'Usage: %s install %s\n' "${0}" "${usage}" >&2
exit 1
fi
root="${1}"
if [ "x${arch}" = 'x' ]; then
uname_m="$( (uname -m) 2>/dev/null)" || uname_m='?'
uname_s="$( (uname -s) 2>/dev/null)" || uname_s='?'
case "${uname_m}:${uname_s}" in
'i686:Linux') arch='i686-linux-glibc';;
'x86_64:Linux') arch='amd64-linux-glibc';;
'?:?') error 2 'Error: Architecture unknown';;
*) error 2 'Error: Architecture unsupported';;
esac
fi
info 'Using architecture %s' "${arch}"
if [ "x${plat}" = 'x' ]; then
plat='dev'
fi
info 'Using platform %s' "${plat}"
if [ "x${mirror}" = 'x' ]; then
rand=$(date '+%S')
rand=$(($rand % 2))
case ${rand} in
0)
mirror='http://mirror.gnu.dk/pub/proteanos'
;;
1)
mirror='http://mirror.oss.maxcdn.com/proteanos'
;;
esac
fi
info 'Using mirror %s' "${mirror}"
info 'Setting up root...'
mkdir -p "${root}/etc/opkg" \
"${root}/var/lib/opkg/lists" "${root}/var/lib/opkg/info" \
"${root}/var/cache/opkg/archives" "${root}/tmp/opkg" || \
error 2 'Failed to set up root'
info 'Configuring opkg and retrieving Packages...'
exec 3>"${root}/etc/opkg/opkg.conf" || \
error 2 'Failed to open opkg.conf'
for aps in "${arch}_${plat}_base" "${arch}_all_base" 'all_all_base' \
'src_all_base'; do
url_aps="$(printf '%s\n' "${aps}" | sed 's|_|/|g')"
feed="${mirror}/feeds/dev/trunk/${url_aps}"
printf 'src %s %s\n' "trunk_${aps}" "${feed}" >&3
wget -q -O "${root}/var/lib/opkg/lists/trunk_${aps}" \
"${feed}/Packages" || \
error 2 'Failed to download %s' "${feed}/Packages"
sha256sum="$(sha256sum \
"${root}/var/lib/opkg/lists/trunk_${aps}" | \
cut -d ' ' -f 1)"
printf '%s' "${SHA256SUMS}" | grep -Fq "${sha256sum} ${aps}" \
|| error 2 'Checksum of Packages index file failed'
done
printf '\ndest root /\n' >&3
printf 'arch %s 1\n' 'all' "${arch}" 'src' >&3
exec 3>&-
while IFS='' read -r line; do
if [ "x${line%: *}" = 'xPackage' ]; then
package="${line#Package: }"
elif [ "x${line%: *}" = 'xFilename' ]; then
filename="${line#Filename: }"
elif [ "x${line%: *}" = 'xSHA256sum' ]; then
sha256sum="${line#SHA256sum: }"
elif [ "x${line}" = 'x' ]; then
printf '%s\n' "${PKGS}" | grep -Fq " ${package} " || \
continue
get_pkg "${root}" "${mirror}" \
"${package}" "${filename}" "${sha256sum}"
fi
done <<-EOF
$(cat "${root}/var/lib/opkg/lists/trunk_"*)
EOF
configure_pkgs "${root}"
rm "${root}/var/cache/opkg/archives/"*.opk
[ -r /etc/resolv.conf ] && cp /etc/resolv.conf "${root}/etc"
[ -r /etc/hostname ] && cp /etc/hostname "${root}/etc"
}
get_pkg()
{
local root="${1}"
local mirror="${2}"
local package="${3}"
local filename="${4}"
local sha256sum="${5}"
local file=
local control=
local field=
local printed=
info 'Downloading %s...' "${package}"
filename="${filename#../../../../../../}"
wget -q -O "${root}/var/cache/opkg/archives/${filename##*/}" \
"${mirror}/${filename}" || error 2 'Failed to download package'
filename="var/cache/opkg/archives/${filename##*/}"
printf '%s %s\n' "${sha256sum}" "${root}/${filename}" | \
sha256sum -c >/dev/null 2>&1 \
|| error 2 'Checksum of source package file failed'
info 'Unpacking %s...' "${package}"
mkdir "${root}/tmp/opkg/${package}"
(
cd "${root}"
tar -xzOf "${filename}" data.tar.gz \
>"tmp/opkg/${package}/data.tar.gz"
tar -xzf "tmp/opkg/${package}/data.tar.gz"
cd "tmp/opkg/${package}"
tar -xzOf "../../../${filename}" control.tar.gz | \
tar -xz
)
for file in "${root}/tmp/opkg/${package}/"*; do
mv "${file}" "${root}/var/lib/opkg/info/${package}.${file##*/}"
done
tar -tz "${root}/tmp/opkg/${package}/data.tar.gz" | sed 's/^\.//' \
>"${root}/var/lib/opkg/info/${package}.list"
rm -f "${root}/tmp/opkg/${package}/data.tar.gz"
rmdir "${root}/tmp/opkg/${package}"
# Write status file.
exec 3>>"${root}/var/lib/opkg/status"
control="${root}/var/lib/opkg/info/${package}.control"
for field in Package Version Depends Recommends Suggests \
Provides Replaces Conflicts; do
grep "^${field}: " "${control}" >&3
done
printf 'Status: install ok unpacked\n' >&3
for field in Essential Architecture; do
grep "^${field}: " "${control}" >&3
done
if [ -r "${root}/var/lib/opkg/info/${package}.conffiles" ]; then
printed=false
while read -r file; do
${printed} || printf 'Conffiles:\n' >&3
printf ' %s %s\n' "${file}" "$(md5sum \
"${root}/${file}" | cut -d ' ' -f 1)" \
>&3
printed=true
done <"${root}/var/lib/opkg/info/${package}.conffiles"
fi
printf 'Installed-Time: %s\n\n' "$(date '+%s')" >&3
exec 3>&-
}
configure_pkgs()
{
local root="${1}"
local opk=
local pkg=
local script=
for opk in "${root}/var/cache/opkg/archives/"*.opk; do
pkg="${opk##*/}"
pkg="${pkg%%_*}"
info 'Configuring %s...' "${pkg}"
for script in 'preinst' 'postinst'; do
if [ -x "${root}/var/lib/opkg/info/${pkg}.${script}" ]
then
chroot "${root}" \
"/var/lib/opkg/info/${pkg}.${script}" \
configure
fi
done
done
}
cmd_shell()
{
local root=
local arch=
if [ ${#} -ne 1 ]; then
printf 'Usage: %s shell \n' "${0}" >&2
exit 1
fi
root="${1}"
if ! [ -d "${root}" ] || ! [ -r "${root}/etc/proteanos_arch" ]; then
error 2 'Error: ProteanOS root file system not found'
fi
arch="$(cat "${root}/etc/proteanos_arch")"
case "${arch}" in
*'-linux-'*)
mount -t proc proc "${root}/proc"
mount -t sysfs sys "${root}/sys"
mount -o bind /dev "${root}/dev"
mount -t devpts -o noexec,nosuid,gid=5,mode=0620 \
devpts "${root}/dev/pts"
;;
*)
error 2 'ProteanOS architecture %s not supported' \
"${arch}"
esac
chroot "${root}" /bin/sh
printf '\nExiting...\n'
case "$(cat "${root}/etc/proteanos_arch")" in
*'-linux-'*)
umount "${root}/dev/pts"
umount "${root}/proc"
umount "${root}/sys"
while ! umount "${root}/dev"; do
# umount sometimes complains that ${root}/dev is
# busy. Here's a kludge to try to handle that.
# This is a bind mount, so we better make sure
# it gets unmounted; otherwise, `rm -Rf ${root}`
# can be painful.
sleep 1
done
;;
esac
}
main "${@}"